/* Problem URL: https://codeforces.com/gym/103388/problem/M */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;

    vvi graph(1);
    int cur = 1;

    vi status(1);
    vi chosen(1);
    vi parent(1);

    function<int(int)> dfs = [&](int i) {
        if (status[i] != -1) {
            return i;
        }

        while (chosen[i] < graph[i].size()) {
            int res = dfs(graph[i][chosen[i]]);

            if (res == -1) {
                chosen[i]++;
                continue;
            }

            return res;
        }

        return -1;
    };

    while (q--) {
        int p, c;
        cin >> p >> c;

        if (p == 1) {
            graph[c - 1].push_back(graph.size());
            graph.emplace_back();
            parent.push_back(c - 1);
            status.push_back(0);
            chosen.push_back(0);
            continue;
        }

        status[c - 1] = -1;

        int ans = cur - 1;
        int tmp;
        while ((tmp = dfs(ans)) == -1) {
           ans = parent[ans];
        }

        cur = tmp + 1;
        cout << cur << '\n';
    }
}
